<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Capsule\Manager;

class PopenerimaanModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "popenerimaan";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "popenerimaan";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "poNumber", "kapalId", "date", "status", "operatingUnit", "quantity", "date_updated", "vendorId", "vendorName", "prNumber", "comments"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "poNumber" => "popenerimaan.poNumber",
        "status" => "popenerimaan.status",
        "kapalId" => "popenerimaan.kapalId",
        "date" => "popenerimaan.date",
        "voyageName" => "voyages.voyageName"
    ];

    /**
     * relation from ' . itempopenerimaan . ' by ' . penerimaanBarangId
     * join itempopenerimaan on itempopenerimaan.poNumber = popenerimaan.penerimaanBarangId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationItemPoPenerimaanBarangId($alias = "itempopenerimaan")
    {
        $this->getQuery()->join("itempopenerimaan as $alias", function ($join) use ($alias) {
            $join->on("$alias.poNumber", "=", "popenerimaan.poNumber");
            $join->on("$alias.kapalId", "=", "popenerimaan.kapalId");
        })
            ->join("item as itemId", "itemId.id", "=", "$alias.itemId");
        return $this;
    }


    public function joinRelationPenerimaanBarangId($alias = "penerimaanBarangId")
    {
        $this->getQuery()->leftjoin("penerimaanbarang as $alias", "$alias.poNumber", "=", "popenerimaan.poNumber");
        return $this;
    }

    public function joinRelationPermintaanBarangId($alias = "permintaanBarangId")
    {
        $this->getQuery()->leftjoin("permintaanbarang as $alias", "$alias.prNumber", "=", "popenerimaan.prNumber");
        return $this;
    }


    public function joinRelationKapalId($alias = "kapalId")
    {
        $this->getQuery()->join("kapal as $alias", "$alias.id", "=", "popenerimaan.kapalId");
        return $this;
    }

    // SYNC ERROR MULAI DARI SINI
    public function syncErrorFromOracleHO($poNumber, $kapalID, $fromCMS = false)
    {
        echo "start sync recovery PO Penerimaan data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Penerimaan PO", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $sqlErrorSync = self::getSyncErrorOracleQuery($poNumber, $kapalID);
        $oracleOCI->getConnection()->select($sqlErrorSync)->execute();
        $rows = $oracleOCI->fetchAll();
        $return = false;
        if ($rows) {
            $item = new self();
            $return = $item->storingDataFromOracle($rows, $fromCMS);
        } else {
            $return = false;
        }
        (new LogsyncoracleModel)->setLogSync("Sync Recovery Penerimaan PO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
        return $return;
    }

    // GENERAL SYNC MULAI DARI SINI
    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start sync PO Penerimaan data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->APPROVED_DATE_PO)) $lastUpdate = $rows->APPROVED_DATE_PO;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }
    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = /*"SELECT
                    --     POV.PO_NUMBER,
                    --     POV.IO,
                    --     POV.APPROVED_DATE_PO,
                    --     POV.OU_NAME,
                    --     POV.PO_QTY,
                    --     POV.VENDOR_ID,
                    --     POV.VENDOR_NAME,
                    --     POV.NO_PR,
                    --     POV.COMMENTS
                    -- FROM pelni_scm_pr_to_po_v POV
                    -- WHERE
                    --   POV.APPROVED_DATE_PO >=
                    --   TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS') 
                    --   AND POV.PO_NUMBER IS NOT NULL
                    -- ORDER BY POV.APPROVED_DATE_PO ASC";*/
                            "SELECT REQUISITION_HEADER_ID, NO_PR, CREATION_DATE, DESCRIPTION, OU_NAME, IO, ORG_CODE, ORG_CODE_ASAL, 
                            PR_QTY, PR_AMOUNT, PO_HEADER_ID, PO_NUMBER, NO_KONTRAK, COMMENTS, PO_QTY, PO_AMOUNT,
                            TO_CHAR( APPROVED_DATE_PO, 'YYYY/MM/DD HH24:MI:SS') AS APPROVED_DATE_PO, VENDOR_ID, VENDOR_NAME, VENDOR_SITE_ID, VENDOR_SITE_CODE, ADDRESS_LINE1, CREATED_BY
                        FROM PELNI_SCM_PR_TO_PO_V
                        WHERE APPROVED_DATE_PO >= TO_TIMESTAMP('" . CARBON::PARSE($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS') AND PO_NUMBER IS NOT NULL
                        GROUP BY REQUISITION_HEADER_ID, NO_PR, CREATION_DATE, DESCRIPTION, OU_NAME, IO, ORG_CODE,
                            ORG_CODE_ASAL, PR_QTY, PR_AMOUNT, PO_HEADER_ID, PO_NUMBER, NO_KONTRAK, COMMENTS, PO_QTY, PO_AMOUNT,
                            APPROVED_DATE_PO, VENDOR_ID, VENDOR_NAME, VENDOR_SITE_ID, VENDOR_SITE_CODE, ADDRESS_LINE1, CREATED_BY";
        return $query;
    }

    public static function getSyncErrorOracleQuery($poNumber, $kapalID)
    {
        $query = "SELECT POV.PO_NUMBER, POV.IO, POV.APPROVED_DATE_PO, POV.OU_NAME, POV.PO_QTY, POV.VENDOR_ID, POV.VENDOR_NAME, POV.NO_PR, POV.COMMENTS
                    FROM pelni_scm_pr_to_po_v POV
                    WHERE POV.PO_NUMBER = '" . $poNumber . "' AND POV.IO = '" . $kapalID . "'";
        return $query;
    }

    public function mapperOracle($oracle, $insertUpdate = "UPDATE")
    {
        $this->poNumber = $oracle->PO_NUMBER;
        $this->kapalId = $oracle->IO;
        $this->date = $oracle->APPROVED_DATE_PO;
        $this->operatingUnit = $oracle->OU_NAME;
        $this->quantity = $oracle->PO_QTY;
        $this->vendorId = $oracle->VENDOR_ID;
        $this->vendorName = $oracle->VENDOR_NAME;
        $this->prNumber = $oracle->NO_PR;
        $this->comments = $oracle->COMMENTS;
        if ($insertUpdate == "INSERT") {
            $this->status = 0;
        }
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        echo "masuk simpan po";
        $poExist = (new self())->getQuery()
            ->where("popenerimaan.poNumber", "=", $oracle->PO_NUMBER)
            ->where("popenerimaan.kapalId", "=", $oracle->IO)
            ->first();
        echo $oracle->PO_NUMBER . " " . $oracle->IO;
        //        var_dump($poExist);
        if ($poExist) {
            echo "masuk update po";
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = self::find($poExist->id);
                $model->mapperOracle($oracle);
                $model->update();

                (new ItempopenerimaanModel())->syncItemFromOracleHO($oracle->PO_NUMBER, $oracle->IO);
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                echo $model->poNumber . " " . $this->getTable() . " updated ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO - " . $model->poNumber, Carbon::now()->toDateTimeString(), "", "updated");
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO - " . $model->poNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            echo "masuk insert po";
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = new self();
                $model->mapperOracle($oracle, "INSERT");
                $model->save();
                (new ItempopenerimaanModel())->syncItemFromOracleHO($oracle->PO_NUMBER, $oracle->IO);
                echo $model->poNumber . " " . $this->getTable() . " inserted ", PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO - " . $model->poNumber, Carbon::now()->toDateTimeString(), "", "inserted");
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }

                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }
                // FUNCTION TO INSERT INTO SYNCERROR TABLE IN CASE THE PROCESS ABOVE HAS SOME ERROR
                $params = json_encode([
                    "PO_NUMBER" => $oracle->PO_NUMBER,
                    "IO" => $oracle->IO
                ]);
                $data = json_encode($oracle);

                $syncErrExist = (new SyncerrorModel())->getQuery()->where("table_name", "=", "pelni_scm_pr_to_po_v")
                    ->where("params", "LIKE", $params)
                    ->where("aplikasi", "=", "HO")
                    ->first();
                /*
                if(! $syncErrExist) {
                    echo "err masuk";
                    $insertSyncErr = new SyncerrorModel();
                    $insertSyncErr->table_name = "pelni_scm_pr_to_po_v";
                    $insertSyncErr->params = $params;
                    $insertSyncErr->data = $data;
                    $insertSyncErr->aplikasi = "HO";
                    $insertSyncErr->date_created = Carbon::now()->toDateTimeString();
                    $insertSyncErr->save();
                } */
                (new SyncerrorModel)->saveError("pelni_scm_pr_to_po_v", $params, $data, "HO");

                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO - " . $model->poNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        }
    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        $modelExist = new self();
        $exist = $modelExist->getQuery()->where("popenerimaan.poNumber", "=", $data->poNumber)->first();
        if (!$exist) {
            //insert PO here
            if ($fromCMS) {
                DB::beginTransaction();
            } else {
                Manager::beginTransaction();
            }
            try {
                $model = new self((array) $data);
                $model->save([], $data->id, 0);
                (new LogsynckapalModel)->setLogSync("PO Penerimaan - " . $data->poNumber, Carbon::now()->toDateTimeString(), "", "inserted");
                if (!empty($data->detail)) {
                    foreach ($data->detail as $detail) {
                        $detailPo = new ItempopenerimaanModel();
                        $detailPo->fill((array) $detail);
                        $detailPo->save([], $detail->id, 0);
                        (new LogsynckapalModel)->setLogSync("PO Penerimaan Detail - " . $detail->poNumber . " - " . $detail->itemId, Carbon::now()->toDateTimeString(), "", "inserted");

                        if (!empty($data->prNumber)) {
                            PopenerimaanModel::updateItemPermintaan($data->poNumber, $data->prNumber, $detail->itemId, $detail->quantity);
                        }
                    }
                }
                if ($fromCMS) {
                    DB::commit();
                } else {
                    Manager::commit();
                }
                return true;
            } catch (\Exception $exception) {
                if ($fromCMS) {
                    DB::rollBack();
                } else {
                    Manager::rollBack();
                }

                $params = json_encode([
                    "poNumber" => $data->poNumber,
                    "kapalId" => $data->kapalId
                ]);
                $dataSave = json_encode($data);
                (new SyncerrorModel)->saveError("popenerimaan", $params, $dataSave, "KAPAL");

                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Transaksi Penerimaan PO - " . $data->poNumber, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                return false;
            }
        } else {
            //update PO here
            $model = self::find($exist->id);
            $model->operatingUnit = $data->operatingUnit;
            $model->quantity = $data->quantity;
            $model->vendorId = $data->vendorId;
            $model->vendorName = $data->vendorName;
            $model->prNumber = $data->prNumber;
            $model->date_updated = $data->date_updated;
            $model->comments = $data->comments;
            $model->update();
            (new LogsynckapalModel)->setLogSync("PO Penerimaan - " . $data->poNumber, Carbon::now()->toDateTimeString(), "", "updated");

            //update PO Detail here, in case any update data from oracle
            if (!empty($data->detail)) {
                foreach ($data->detail as $detail) {
                    echo " data " . $detail->itemId . " | " . $detail->poNumber;
                    $detailPo = (new ItempopenerimaanModel())->getQuery()->where("itempopenerimaan.poNumber", "=", $detail->poNumber)
                        ->where("itempopenerimaan.itemId", "=", $detail->itemId)
                        ->first();
                    if ($detailPo) {
                        $model = new ItempopenerimaanModel();
                        $model = $model::find($detailPo->id);
                        $model->lokasiId = $detail->lokasiId;
                        $model->quantity = $detail->quantity;
                        $model->date_updated = $detail->date_updated;
                        $model->update();
                        (new LogsynckapalModel)->setLogSync("PO Penerimaan Detail - " . $detail->poNumber . " - " . $detail->itemId, Carbon::now()->toDateTimeString(), "", "updated");
                    } else {
                        $model = new ItempopenerimaanModel();
                        $model->fill((array) $detail);
                        $model->save([], $detail->id, 0);
                        (new LogsynckapalModel)->setLogSync("PO Penerimaan Detail - " . $detail->poNumber . " - " . $detail->itemId, Carbon::now()->toDateTimeString(), "", "inserted");

                        if (!empty($data->prNumber)) {
                            PopenerimaanModel::updateItemPermintaan($data->poNumber, $data->prNumber, $detail->itemId, $detail->quantity);
                        }
                    }
                }
            }
            return true;
        }
    }

    public static function updateItemPermintaan($poNumber, $prNumber, $itemID, $qty)
    {
        $detailItemSPB = (new ItempermintaanbarangModel())->getQuery()->select(["id", "disetujui"])
            ->where("itempermintaanbarang.prNumber", "=", $prNumber)
            ->where("itempermintaanbarang.itemId", "=", $itemID)
            ->first();
        if ($detailItemSPB) {
            $modelItemSPBUpdate = new ItempermintaanbarangModel();
            $modelItemSPBUpdate = $modelItemSPBUpdate::find($detailItemSPB->id);
            $modelItemSPBUpdate->disetujui = floatval($detailItemSPB->disetujui + $qty);
            $modelItemSPBUpdate->update();

            (new LogsynckapalModel)->setLogSync("PO Penerimaan #" . $poNumber . " - Update Qty Disetujui di PR #" . $prNumber . " - Item: #" . $itemID . " - Qty: " . floatval($detailItemSPB->disetujui + $qty), Carbon::now()->toDateTimeString(), "", "updated");
        }
    }

    public static function getPo($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_po";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 8)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("PO Penerimaan HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo " data " . $item->poNumber;
                            \App\Http\Models\PopenerimaanModel::storeFromHO($item, $fromCMS);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;
                } catch (Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("PO Penerimaan HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("PO Penerimaan HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}
